      SUBROUTINE IDS7R(N,X,Y,Y1,Y2,Y3)                                  00000010
      DIMENSION X(N),Y(N),Y1(N),Y2(N),Y3(N)                             00000020
      INTEGER N,N1,K,J1,J2,N2                                           00000030
      REAL X,Y,Y1,Y2,Y3,D1,D2,U1,U2,V1,V2,S1,S2,T1,T2,Z,R               00000040
      N1=N-1                                                            00000050
      D1=0.5*Y2(1)                                                      00000060
      D2=0.5*Y2(N)                                                      00000070
      Y2(1)=0.                                                          00000080
      Y3(1)=0.                                                          00000090
      DO 2 K=1,N1                                                       00000100
      J2=K+1                                                            00000110
      U2=1./(X(J2)-X(K))                                                00000120
      V2=U2*U2                                                          00000130
      S2=10.*U2*V2*(Y(J2)-Y(K))                                         00000140
      T2=4.*V2*(Y1(J2)+Y1(K))                                           00000150
      IF(K.EQ.1) GO TO 1                                                00000160
      Z=1./(3.*(U1+U2)+U1*Y2(J1))                                       00000170
      Y2(K)=-Z*U2                                                       00000180
      R=(S2-S1)-(T2-T1)+2.*(V1-V2)*Y1(K)                                00000190
      IF(K.EQ.2) R=R+U1*D1                                              00000200
      IF(K.EQ.N1) R=R+U2*D2                                             00000210
      Y3(K)=Z*(R+U1*Y3(J1))                                             00000220
    1 J1=K                                                              00000230
      U1=U2                                                             00000240
      V1=V2                                                             00000250
      S1=S2                                                             00000260
      T1=T2                                                             00000270
    2 CONTINUE                                                          00000280
      Y2(N1)=Y3(N1)                                                     00000290
      IF(N1.LE.2) GO TO 4                                               00000300
      N2=N1-1                                                           00000310
      DO 3 J1=2,N2                                                      00000320
      K=N-J1                                                            00000330
      Y2(K)=Y3(K)-Y2(K)*Y2(K+1)                                         00000340
    3 CONTINUE                                                          00000350
    4 Y2(1)=2.*D1                                                       00000360
      DO 5 K=2,N1                                                       00000370
    5 Y2(K)=2.*Y2(K)                                                    00000380
      DO 6 K=2,N                                                        00000390
      U1=X(K)-X(K-1)                                                    00000400
      U2=1./U1                                                          00000410
      V1=U2*U2                                                          00000420
      R=20.*(Y(K)-Y(K-1))*U2-12.*Y1(K-1)-8.*Y1(K)                       00000430
    6 Y3(K-1)=3.*V1*(R+U1*(Y2(K)-Y2(K-1)*3.))                           00000440
      U1=X(N)-X(N-1)                                                    00000450
      U2=1./U1                                                          00000460
      V1=U2*U2                                                          00000470
      S1=6.*(Y(N)-Y(N-1))*U2-3.*(Y1(N-1)+Y1(N))+0.5*U1*                 00000480
     1(Y2(N)-Y2(N-1))                                                   00000490
      S2=8.*Y1(N-1)+7.*Y1(N)-15.*(Y(N)-Y(N-1))*U2+0.5*U1*               00000500
     1(3.*Y2(N-1)-2.*Y2(N))                                             00000510
      Y3(N)=(60.*S1+24.*S2)*V1+Y3(N-1)                                  00000520
      RETURN                                                            00000530
      END                                                               00000540
